<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml"/>
	<xsl:variable name="trace-view">/visualizer</xsl:variable>
	<xsl:variable name="trace-raw">/visualizer</xsl:variable>
	<xsl:variable name="imgbase">/nkse/style/img/</xsl:variable>
	<xsl:variable name="explorer">/tools/explore/</xsl:variable>

	 <xsl:include href="res:/nkse/style/xsl/format_resolution.xsl"/>	

	<xsl:template match="/detail">
		
		<div>
		<script language="Javascript">
			<xsl:comment>
				function getNamedChild(node,childName)
				{	if (node)
					{	for(child=node.firstChild; child; child=child.nextSibling )
						{	//console.log(child.nodeName);
							if (child.nodeType==1 &amp;&amp; child.nodeName==childName)
							{	return child;
							}
						}
					}
				}
				
				function fold(id)
				{ div=document.getElementById(id);
				  expand=div.style.display=='none';
				  //img=getNamedChild(getNamedChild(getNamedChild(getNamedChild(tr,"TD"),"DIV"),"A"),"IMG");
				  p = div.parentNode;
				  img = getNamedChild(getNamedChild(getNamedChild(p,"DIV"),"A"),"IMG");
				  //img = div.parentNode;
				  //alert(img);
				
				  if (expand)
				  { img.src="<xsl:value-of select="$imgbase"/>minus.png";
				    div.style.display="";
				  }
				  else
				  { img.src="<xsl:value-of select="$imgbase"/>plus.png";
				    div.style.display="none";
				  }
				}
				
			</xsl:comment>
		</script>
				<div >
					<input type="button" value="back" onclick="parent.location='{$trace-view}/{/detail/hash}'" class="btn"/>
					<input type="button" value="view response" onclick="parent.location='{$trace-raw}/{/detail/hash}/response/{/detail/requestIndex}'" class="btn"/>
					<input type="button" value="all traces" onclick="parent.location='{$trace-view}/'" class="btn"/>
				</div>
				
				<table class="data-table" style="clear: both;">
				<tr class="vis-title">
					<td colspan="2">Request</td>
				</tr>
				<tr>
					<td class="label">Requestor:</td>
					<td>
						<xsl:choose>
							<xsl:when test="parentRequestIndex">
								<a href="{$trace-view}/{/detail/hash}/detail/{parentRequestIndex}"><xsl:value-of select="parentEndpoint"/></a>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="parentEndpoint"/>
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
	          <tr>
	            <td class="label">Verb:</td>
	            <td><xsl:value-of select="trace/verb"/></td>
	          </tr>
				<tr>
					<td class="label">Identifier:</td>
					<td><xsl:value-of select="trace/identifier"/></td>
				</tr>
				<tr>
					<td class="label">Request Scope:</td>
					<td>
						<xsl:for-each select="trace/reqctx/level">
							<xsl:variable name="class">
								<xsl:choose>
									<xsl:when test="position() mod 2 = 0">
										<xsl:text>evenrow</xsl:text>
									</xsl:when>
									<xsl:otherwise>
										<xsl:text>oddrow</xsl:text>
									</xsl:otherwise>  
								</xsl:choose>
							</xsl:variable>							
							<div class="{$class}">
								<xsl:choose>
									<xsl:when test="hash">
										<a href="{$explorer}{hash}">
											<xsl:value-of select="space"/>
										</a>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="space"/>
									</xsl:otherwise>
								</xsl:choose>
							</div>
						</xsl:for-each>																				
						
					</td>
				</tr>
				<xsl:if test="trace/primary">
				<tr>
					<td class="label">Primary:</td>
					<td><a href="{$trace-raw}/{/detail/hash}/primary/{/detail/requestIndex}"><xsl:value-of select="trace/primary"/></a></td>
				</tr>
				</xsl:if>
				<tr>
					<td class="label">Representation:</td>
					<td><xsl:value-of select="trace/reqRep"/></td>
				</tr>
				<tr>
					<td class="label">Priority:</td>
					<td><xsl:value-of select="trace/priority"/></td>
				</tr>
				<tr><td class="label">Headers:</td><td>
					<xsl:choose>
						<xsl:when test="trace/headers/value">
							<xsl:for-each select="trace/headers/value">
								<xsl:variable name="class">
									<xsl:choose>
										<xsl:when test="position() mod 2 = 0">
											<xsl:text>evenrow</xsl:text>
										</xsl:when>
										<xsl:otherwise>
											<xsl:text>oddrow</xsl:text>
										</xsl:otherwise>  
									</xsl:choose>
								</xsl:variable>							
								<div class="{$class}">
									<xsl:value-of select="@key"/> = <xsl:value-of select="."/>
								</div>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>[none]</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				
				<tr class="vis-title">
					<td colspan="2">Resolution</td>
				</tr>
				<tr>
					<td class="label">Trace:</td>
					<td>
						<xsl:for-each select="resolve">
							<xsl:call-template name="resolution"/>
						</xsl:for-each>
					</td>
				</tr>
				<tr>
					<td class="label">Physical Endpoint:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/endpointHash">
								<a href="{$explorer}{trace/endpointHash}">
									<xsl:value-of select="trace/endpointToString"/>
								</a>
							</xsl:when>
							<xsl:when test="trace/endpointToString"><xsl:value-of select="trace/endpointToString"/></xsl:when>
							<xsl:otherwise>(from cache)</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr>
					<td class="label">Logical Endpoint:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/logicalHash">
								<a href="{$explorer}{trace/logicalHash}">
									<xsl:value-of select="trace/logicalEndpoint"/>
								</a>
							</xsl:when>
							<xsl:when test="trace/logicalEndpoint">
								<xsl:value-of select="trace/logicalEndpoint"/>
							</xsl:when>
							<xsl:otherwise>
								[none]
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr>
					<td class="label">Resolved Scope:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/endpoint">
								<xsl:for-each select="trace/resctx/level">
									<xsl:variable name="class">
										<xsl:choose>
											<xsl:when test="position() mod 2 = 0">
												<xsl:text>evenrow</xsl:text>
											</xsl:when>
											<xsl:otherwise>
												<xsl:text>oddrow</xsl:text>
											</xsl:otherwise>  
										</xsl:choose>
									</xsl:variable>							
									<div class="{$class}">
										<xsl:choose>
											<xsl:when test="hash">
												<a href="{$explorer}{hash}">
													<xsl:value-of select="space"/>
												</a>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="space"/>
											</xsl:otherwise>
										</xsl:choose>
									</div>
								</xsl:for-each>																												
							</xsl:when>
							<xsl:otherwise>unknown*</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				
				<tr class="vis-title">
					<td colspan="2">Endpoint</td>
				</tr>
				<tr>
					<td class="label">Endpoint Class:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/endpoint"><xsl:value-of select="trace/endpoint"/></xsl:when>
							<xsl:otherwise>(from cache)</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr>
					<td class="label">Endpoint Space:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/endpointHomeHash">
								<a href="{$explorer}{trace/endpointHomeHash}">
									<xsl:value-of select="trace/endpointHomeContext"/>
								</a>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="trace/endpointHomeContext"/>
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr>
					<td class="label">Subrequests:</td>
					<td>
					<xsl:choose>
						<xsl:when test="subrequests/sr">
							<xsl:for-each select="subrequests/sr">
								<xsl:variable name="class">
									<xsl:choose>
										<xsl:when test="position() mod 2 = 0">
											<xsl:text>evenrow</xsl:text>
										</xsl:when>
										<xsl:otherwise>
											<xsl:text>oddrow</xsl:text>
										</xsl:otherwise>  
									</xsl:choose>
								</xsl:variable>
								<div class="{$class}">
									<a href="{$trace-view}/{/detail/hash}/detail/{index}">
									<xsl:value-of select="trace/verb"/><xsl:text> </xsl:text><xsl:value-of select="trace/identifier"/>
									</a>
								</div>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>[none]</xsl:otherwise>
					</xsl:choose>
					</td>
				</tr>
				<tr class="vis-title">
					<td>Response
					</td>
					<td><input type="button" value="view" onclick="parent.location='{$trace-raw}/{/detail/hash}/response/{/detail/requestIndex}'" class="btn"/>
					</td>
				</tr>
				<tr>
					<td class="label">Type:</td>
					<td>
						<xsl:choose>
							<xsl:when test="trace/responseName">
								<a href="{$explorer}{trace/responseHash}">
									<xsl:value-of select="trace/responseName"/>
								</a>
								(<xsl:value-of select="trace/responseClass"/>)
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="trace/responseClass"/>
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
				<tr><td class="label">Headers:</td><td>
					<xsl:choose>
						<xsl:when test="trace/usermeta/value">
							<xsl:for-each select="trace/usermeta/value">
								<xsl:variable name="class">
									<xsl:choose>
										<xsl:when test="position() mod 2 = 0">
											<xsl:text>evenrow</xsl:text>
										</xsl:when>
										<xsl:otherwise>
											<xsl:text>oddrow</xsl:text>
										</xsl:otherwise>  
									</xsl:choose>
								</xsl:variable>							
								<div class="{$class}">
									<xsl:choose>
									<!--
										<xsl:when test="@key='ad'">
											[Additional dependencies on locally cached responses]
										</xsl:when>
										-->
										<xsl:otherwise>
											<xsl:value-of select="@key"/> = <xsl:value-of select="."/>
										</xsl:otherwise>
									</xsl:choose>
									
								</div>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>[none]</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				<tr><td class="label">Expiry:</td><td>
					<xsl:for-each select="trace/expiry/e">
						<xsl:call-template name="expiry"/>
					</xsl:for-each>
				</td></tr>
				<tr><td class="label">isExpired?:</td><td>
					<xsl:choose>
						<xsl:when test="trace/isExpired"><xsl:value-of select="trace/isExpired"/></xsl:when>
						<xsl:otherwise>unknown*</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				<tr><td class="label">Cost:</td><td>
					<xsl:choose>
						<xsl:when test="trace/cost"><xsl:value-of select="trace/cost"/></xsl:when>
						<xsl:otherwise>unknown*</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				<tr><td class="label">Response Scope:
					</td>
					<td>
						(yellow area indicates scope used in processing request)
						<xsl:choose>
							<xsl:when test="trace/scope">
								<xsl:variable name="scope"><xsl:value-of select="trace/scope"/></xsl:variable>
								<xsl:for-each select="trace/reqctx/level">
									<xsl:variable name="class">
										<xsl:choose>
											<xsl:when test="$scope+1 >= position() and position() mod 2 = 0">
												<xsl:text>evenrowScope</xsl:text>
											</xsl:when>
											<xsl:when test="$scope+1 >= position()">
												<xsl:text>oddrowScope</xsl:text>
											</xsl:when>
											<xsl:when test="position() mod 2 = 0">
												<xsl:text>evenrow</xsl:text>
											</xsl:when>
											<xsl:otherwise>
												<xsl:text>oddrow</xsl:text>
											</xsl:otherwise>  
										</xsl:choose>
									</xsl:variable>							
									<div class="{$class}">
										<xsl:value-of select="space"/>
									</div>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>unknown*
							</xsl:otherwise>																			
						</xsl:choose>
					</td>
				</tr>
					

			</table>

		</div>		
	</xsl:template>
	
	<xsl:template name="expiry">
		<div>
			<xsl:value-of select="@msg"/>
			<xsl:if test="e">
				<div style="margin-left: 1em;">
				<xsl:for-each select="e">
					<xsl:call-template name="expiry"/>
				</xsl:for-each>
				</div>
			</xsl:if>
		</div>
	</xsl:template>		
	
</xsl:stylesheet>
